# DataExchange
TKXSBase
Interface

# Interface_GTool Class Reference

GTool - General Tool for a Model
Provides the functions performed by Protocol/GeneralModule for
entities of a Model, and recorded in a GeneralLib
Optimized : once an entity has been queried, the GeneralLib is
not longer queried
Shareable between several users : as a Handle
.

`#include <Interface_GTool.hxx>`

## Public Member Functions

Standard_EXPORT | Interface_GTool ()
| Creates an empty, not set, GTool .
Standard_EXPORT | Interface_GTool (const Handle(Interface_Protocol)&proto, const Standard_Integer nbent=0)
| Creates a GTool from a Protocol Optional starting count of entities .
Standard_EXPORT void | SetSignType (const Handle(Interface_SignType)&sign)
| Sets a new SignType .
Standard_EXPORT Handle_Interface_SignType | SignType () const
| Returns the SignType. Can be null .
Standard_EXPORT Standard_CString | SignValue (const Handle(Standard_Transient)&ent, const Handle(Interface_InterfaceModel)&model) const
| Returns the Signature for a Transient Object in a Model It calls SignType to do that If SignType is not defined, return ClassName of <ent> .
Standard_EXPORT Standard_CString | SignName () const
| Returns the Name of the SignType, or "Class Name" .
Standard_EXPORT void | SetProtocol (const Handle(Interface_Protocol)&proto, const Standard_Boolean enforce=Standard_False)
| Sets a new Protocol if <enforce> is False and the new Protocol equates the old one then nothing is done .
Standard_EXPORT Handle_Interface_Protocol | Protocol () const
| Returns the Protocol. Warning : it can be Null .
Standard_EXPORT Interface_GeneralLib & | Lib ()
| Returns the GeneralLib itself .
Standard_EXPORT void | Reservate (const Standard_Integer nb, const Standard_Boolean enforce=Standard_False)
| Reservates maps for a count of entities <enforce> False : minimum count <enforce> True : clears former reservations Does not clear the maps .
Standard_EXPORT void | ClearEntities ()
| Clears the maps which record, for each already recorded entity its Module and Case Number .
Standard_EXPORT Standard_Boolean | Select (const Handle(Standard_Transient)&ent, Handle(Interface_GeneralModule)&gmod, Standard_Integer &CN, const Standard_Boolean enforce=Standard_False)
| Selects for an entity, its Module and Case Number It is optimised : once done for each entity, the result is mapped and the GeneralLib is not longer queried <enforce> True overpasses this optimisation .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Attributes

Handle_Interface_Protocol | theproto
Handle_Interface_SignType | thesign
Interface_GeneralLib | thelib
Interface_DataMapOfTransientInteger | thentnum
TColStd_IndexedDataMapOfTransientTransient | thentmod

## Constructor & Destructor Documentation

Standard_EXPORT Interface_GTool::Interface_GTool | ( |  | ) |

Standard_EXPORT Interface_GTool::Interface_GTool | ( | const Handle(Interface_Protocol)& | proto,
|  | const Standard_Integer | nbent = `0`
| ) |

## Member Function Documentation

Standard_EXPORT void Interface_GTool::ClearEntities | ( |  | ) |

Standard_EXPORT const Interface_GTool::Handle | ( | Standard_Type |  | ) | const

Standard_EXPORT Interface_GeneralLib& Interface_GTool::Lib | ( |  | ) |

Standard_EXPORT Handle_Interface_Protocol Interface_GTool::Protocol | ( |  | ) | const

Standard_EXPORT void Interface_GTool::Reservate | ( | const Standard_Integer | nb,
|  | const Standard_Boolean | enforce = `Standard_False`
| ) |

Standard_EXPORT Standard_Boolean Interface_GTool::Select | ( | const Handle(Standard_Transient)& | ent,
|  | Handle(Interface_GeneralModule)& | gmod,
|  | Standard_Integer & | CN,
|  | const Standard_Boolean | enforce = `Standard_False`
| ) |

Standard_EXPORT void Interface_GTool::SetProtocol | ( | const Handle(Interface_Protocol)& | proto,
|  | const Standard_Boolean | enforce = `Standard_False`
| ) |

Standard_EXPORT void Interface_GTool::SetSignType | ( | const Handle(Interface_SignType)& | sign | ) |

Standard_EXPORT Standard_CString Interface_GTool::SignName | ( |  | ) | const

Standard_EXPORT Handle_Interface_SignType Interface_GTool::SignType | ( |  | ) | const

Standard_EXPORT Standard_CString Interface_GTool::SignValue | ( | const Handle(Standard_Transient)& | ent,
|  | const Handle(Interface_InterfaceModel)& | model
| ) | const

## Field Documentation

Interface_GeneralLib Interface_GTool::thelib `[private]`

TColStd_IndexedDataMapOfTransientTransient Interface_GTool::thentmod `[private]`

Interface_DataMapOfTransientInteger Interface_GTool::thentnum `[private]`

Handle_Interface_Protocol Interface_GTool::theproto `[private]`

Handle_Interface_SignType Interface_GTool::thesign `[private]`

The documentation for this class was generated from the following file:

- Interface_GTool.hxx